/*
 *	test read from i/o memory
 */
#include <stdio.h>
#include <conio.h>
#include <ctype.h>
#include <osbind.h>

#define SCREEN_ADDRESS	0x00ff8201
#define MFP_ADDRESS		0x00fffa2d

int input(void);

int main(int argc,char **argv)
{
int c = 0;
long addr;
char x;
char *savestack = NULL;

	printf("\tTest reading addresses in I/O memory\n");
	printf("\n\tNow in %s state\n",savestack?"supervisor":"user");

	while(c != 'X') {
		printf("\tA => select any memory address\n");
		printf("\tM => read MFP address (nonexistent on Falcon)\n");
		printf("\tV => read screen address (exists on all systems)\n");
		printf("\tS => switch to %s state\n",savestack?"user":"supervisor");
		printf("\tX => exit\n\t");
		c = input();
		switch(c) {
		case 'A':
			printf("  Enter address (in hexadecimal): ");
			scanf("%lx",&addr);
			printf("\tOK to read address 0x%08x? ",addr);
			if (input() == 'Y') {
				x = *(volatile char *)addr;
				printf("\n\tAddress 0x%08x read successfully\n\n",addr);
			}
			break;
		case 'M':
			x = *(volatile char *)MFP_ADDRESS;
			printf("\n\tAddress 0x%08x read successfully\n\n",MFP_ADDRESS);
			break;
		case 'V':
			x = *(volatile char *)SCREEN_ADDRESS;
			printf("\n\tAddress 0x%08x read successfully\n\n",SCREEN_ADDRESS);
			break;
		case 'S':
			if (savestack) {
				Super(savestack);
				savestack = NULL;
			} else {
				savestack = Super(NULL);
			}
			printf("\n\tSwitched to %s state\n\n",savestack?"supervisor":"user");
		}
	}

	return 0;
}

int input()
{
int c;

	while(1) {
		c = cgetc();
		if (c)
			break;
		cget();		/* ignore non-ascii keys */
	}
	return toupper(c);
}
